open Rand_sml;;
open Format;;

let print_sml ppf l = List.iter (fun lxm -> Print_sml.lexem ppf lxm) l;;

let main () =
 if Array.length Sys.argv < 2
 then failwith "Usage rand <number of tags> [seed]"
 else
 let n = int_of_string Sys.argv.(1) in
 if Array.length Sys.argv = 3 then 
   let seed = int_of_string Sys.argv.(2) in
   Random.init seed
 else ();
 print_sml std_formatter (rand_sml n);
 print_newline ();;

main ();;
