type color =
| Red | Green | Blue | Cyan | Magenta | Yellow | Black | White | Initial;;

type attribute = {
 u : int; 
 s : bool;
 em : bool;
 i : bool;
 b : bool;
 tt : bool;
 size : int;
 color : color;
};;

type tag_type =
 | U
 | S
 | EM
 | I
 | B
 | TT
 | PL
 | SZ of int
 | Color of color;;

type lexem =
   | Text of string
   | Space of char
   | Open of tag_type
   | Close of tag_type;;

type decorated_text = string * attribute;;

type 'a llist =
  | Lnil
  | Lcons of 'a * 'a llist Lazy.t
;;
