open Sem;;
open Lex;;

let check_ic f1 f2 =
 let ic1 = open_in f1 in
 let ic2 = open_in f2 in
(***********************
 let s1 = semant (lex ic1)
 and s2 = semant (lex ic2) in
 let c1 = s1 = s2 in
 (*print_string "BEGIN s1:\n";
  List.iter (fun (s, _) -> print_string s; print_newline ()) s1;
  print_string "\nEND s1\nBEGINs2:\n";
  List.iter (fun (s, _ ) -> print_string s; print_newline ()) s2;
  print_string "\nEND s2"; print_newline();
  seek_in ic1 0;
  seek_in ic2 0;
  let ls1 = lsemant (llex ic1)
  and ls2 = lsemant (llex ic2) in
  print_string "BEGIN ls1:\n";
  let rec llist_iter f = function
    | Lnil -> () | Lcons (x, l) -> f x; llist_iter f (Lazy.force l) in
  llist_iter (fun (s, _) -> print_string s; print_newline ()) ls1;
  print_string "\nEND ls1\nBEGIN ls2:\n";
  llist_iter (fun (s, _ ) -> print_string s; print_newline ()) ls2;
  print_string "\nEND ls2"; print_newline();*)

 seek_in ic1 0;
 seek_in ic2 0;
***********************)
 let c2 = lequal (lsemant (llex ic1)) (lsemant (llex ic2)) in
 (*print_string (Printf.sprintf "Semant : %s\nLSemant : %s"
               (string_of_bool c1)(string_of_bool c2));
  print_newline();*)
(* assert (c1 = c2);*)
 c2;;

let rec list_find2 f l1 l2 =
  match l1, l2 with
  | x :: l1, y :: l2 -> if f x y then x, y else list_find2 f l1 l2
  | _ -> raise Not_found;;

open Sml;;

let rec llist_find2 f l1 l2 =
  match l1, l2 with
  | Lcons (x, l1), Lcons (y, l2) ->
     if f x y then x, y else llist_find2 f (Lazy.force l1) (Lazy.force l2)
  | _ -> raise Not_found;;

let give_error f1 f2 = 
 let ic1 = open_in f1 in
 let ic2 = open_in f2 in
 let s1 = lsemant (llex ic1)
 and s2 = lsemant (llex ic2) in
 let diff = llist_find2 (fun x y -> x <> y) s1 s2 in
 let e1 = match diff with
 | (s1, _), (s2, _) -> Printf.sprintf "%s is not %s." s1 s2 in
 error (Printf.sprintf "Semantic Mismatch for %s\n%s" f1 e1);;

let check_sml_ng f1 f2 =
 if not (check_ic f1 f2) then
  give_error f1 f2
 else exit 0;;
 
let main () =
  check_sml_ng Sys.argv.(1) Sys.argv.(2);;

main ();;
